//	Local routines to facilitate array filling

#include "StdAfx.h"

#include "special.h"

static POINT *vpl;
static int *npl;
static char *cpl;

void initialize(POINT *vpp, int *npp, char *cpp)
{
	vpl = vpp;	npl = npp; cpl = cpp;
}

int rectangle(int x0, int y0, int x1, int y1, BOOL full)
{
	vpl->x = x0;	vpl->y = y0;	vpl++;
	vpl->x = x1;	vpl->y = y1;	vpl++;
	*cpl++ = full==TRUE? RECTANGLE_FILLED_SH: RECTANGLE_SH;	
	*npl++ = 2;	
	return 1;
}

int ellipse(int x0, int y0, int x1, int y1, BOOL full)
{
	vpl->x = x0;	vpl->y = y0;	vpl++;
	vpl->x = x1;	vpl->y = y1;	vpl++;
	*cpl++ = full==TRUE? ELLIPSE_FILLED_SH: ELLIPSE_SH;	
	*npl++ = 2;	
	return 1;
}

int line(int x0, int y0, int x1, int y1)
{
	vpl->x = x0;	vpl->y = y0;	vpl++;
	vpl->x = x1;	vpl->y = y1;	vpl++;
	*cpl++ = POLYLINE_SH;	
	*npl++ = 2;	
	return 1;
}

static int fault(int n, int cause)
{
	CString msg;
	if(cause > 0) msg.Format("CustomDR: Unknown type %d", n);
	else msg.Format("CustomDR: Wrong number of points %d", n);
	AfxMessageBox(msg, MB_ICONERROR);
	return 0;
}

int path(POINT v[], int n, char type)
{
	switch(type) {
	case POLYLINE_SH:	case POLYGON_SH	:	case POLYGON_FILLED_SH:
	//case OPEN_POLYGON_SH: case CLOSED_POLYLINE_SH:
		if(n < 2) return fault(n, 0);
		else break;
	case RECTANGLE_FILLED_SH:	case RECTANGLE_SH:	case ELLIPSE_FILLED_SH:
	case ELLIPSE_SH:	//case CIRCLE_FILLED_SH:	case CIRCLE_SH:
		if(n != 2) return fault(n, 0);
		else break;
	case ARC_SH:
		if(n != 4) return fault(n, 0);
		else break;
	case OPEN_SPLINE_SH:	case CLOSED_SPLINE_SH:	case SPLINE_FILLED_SH:
		if(n < 3) return fault(n, 0);
		else break;
	case OPEN_CUBIC_SH:	case CLOSED_CUBIC_SH:	case CUBIC_FILLED_SH:
		if(n < 4) return fault(n, 0);
		else break;
	default: return fault(type, 1);
	}

	for(int i=0; i<n; i++) {
		vpl->x = v[i].x;	vpl->y = v[i].y;	vpl++;
	}
	*npl++ = n;	
	*cpl++ = type;	
	return 1;
}
